#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
#include <unistd.h>
#include <string.h>

#include "ew_bsp.h"
#include "ew_framework.h"
#include "duml_hal_disp.h"
#include "cutils/properties.h"

#ifdef EW_TEST_LIB
int ew_app_test(void *userdata)
#else
int main()
#endif
{
    int32_t res = 0;
    ew_gui_ctx_handle_t ew_handle;
    printf("gui bsp init start\n");
    res = EwGuiBspInitFromFile(EW_RENDER_TEST_DISP_CFG, EW_RENDER_TEST_INPUT_CFG);
    if(res < 0) {
        printf("EwGuiBspInit failure\n");
        return -1;
    }
    printf("gui bsp init ok\n");
    EwGuiInit(&ew_handle);
    res = EwGuiRun(ew_handle);
    if(res < 0) {
        printf("EwGuiRun failure\n");
        EwGuiDeInit(ew_handle);
        return -1;
    }

    #ifdef EW_TEST_LIB
        sleep(5);
    #else
        while(1) {
            sleep(1);
        }
    #endif

    EwGuiStop(ew_handle);
    EwGuiBspDeInit();
    return 0;
}
